Crazy Eddies GUI System: CEGUI::Scrollbar Class Reference

- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Class List
- Alphabetical List
- Class Hierarchy
- Class Members

# CEGUI::Scrollbar Class Reference

Base scroll bar class. More...

Inheritance diagram for CEGUI::Scrollbar:

[legend]
Collaboration diagram for CEGUI::Scrollbar:

[legend]
List of all members.

## Public Member Functions
float | getDocumentSize (void) const
| Return the size of the document or data.
float | getPageSize (void) const
| Return the page size for this scroll bar.
float | getStepSize (void) const
| Return the step size for this scroll bar.
float | getOverlapSize (void) const
| Return the overlap size for this scroll bar.
float | getScrollPosition (void) const
| Return the current position of scroll bar within the document.
virtual void | initialise (void)
| Initialises the Scrollbar object ready for use.
void | setDocumentSize (float document_size)
| Set the size of the document or data.
void | setPageSize (float page_size)
| Set the page size for this scroll bar.
void | setStepSize (float step_size)
| Set the step size for this scroll bar.
void | setOverlapSize (float overlap_size)
| Set the overlap size for this scroll bar.
void | setScrollPosition (float position)
| Set the current position of scroll bar within the document.
| Scrollbar (const String &type, const String &name)
| Constructor for Scrollbar objects.
virtual | ~Scrollbar (void)
| Destructor for Scrollbar objects.
## Static Public Attributes
static const String | EventNamespace
| Namespace for global events.
static const String | EventScrollPositionChanged
| Name of the event fired when the scroll bar position value changes.
static const String | EventThumbTrackStarted
| Name of the event fired when the user begins dragging the thumb.
static const String | EventThumbTrackEnded
| Name of the event fired when the user releases the thumb.
static const String | EventScrollConfigChanged
| Name of the event fired when the scroll bar configuration data changes.
## Protected Member Functions
void | addScrollbarEvents (void)
| Add scroll bar specific events.
virtual PushButton * | createIncreaseButton (const String &name) const =0
| create a PushButton based widget to use as the increase button for this scroll bar.
virtual PushButton * | createDecreaseButton (const String &name) const =0
| create a PushButton based widget to use as the decrease button for this scroll bar.
virtual Thumb * | createThumb (const String &name) const =0
| create a Thumb based widget to use as the thumb for this scroll bar.
virtual void | updateThumb (void)=0
| update the size and location of the thumb to properly represent the current state of the scroll bar
virtual float | getValueFromThumb (void) const =0
| return value that best represents current scroll bar position given the current location of the thumb.
virtual float | getAdjustDirectionFromPoint (const Point &pt) const =0
| Given window location pt, return a value indicating what change should be made to the scroll bar.
bool | handleThumbMoved (const EventArgs &e)
| handler function for when thumb moves.
bool | handleIncreaseClicked (const EventArgs &e)
| handler function for when the increase button is clicked.
bool | handleDecreaseClicked (const EventArgs &e)
| handler function for when the decrease button is clicked.
bool | handleThumbTrackStarted (const EventArgs &e)
| handler function for when thumb tracking begins
bool | handleThumbTrackEnded (const EventArgs &e)
| handler function for when thumb tracking begins
virtual bool | testClassName_impl (const String &class_name) const
| Return whether this window was inherited from the given class name at some point in the inheritance heirarchy.
virtual void | onScrollPositionChanged (WindowEventArgs &e)
| Handler triggered when the scroll position changes.
virtual void | onThumbTrackStarted (WindowEventArgs &e)
| Handler triggered when the user begins to drag the scroll bar thumb.
virtual void | onThumbTrackEnded (WindowEventArgs &e)
| Handler triggered when the scroll bar thumb is released.
virtual void | onScrollConfigChanged (WindowEventArgs &e)
| Handler triggered when the scroll bar data configuration changes.
virtual void | onMouseButtonDown (MouseEventArgs &e)
| Handler called when a mouse button has been depressed within this window's area.
virtual void | onMouseWheel (MouseEventArgs &e)
| Handler called when the mouse wheel (z-axis) position changes within this window's area.
## Protected Attributes
float | d_documentSize
| The size of the document / data being scrolled thorugh.
float | d_pageSize
| The size of a single 'page' of data.
float | d_stepSize
| Step size used for increase / decrease button clicks.
float | d_overlapSize
| Amount of overlap when jumping by a page.
float | d_position
| Current scroll position.
Thumb * | d_thumb
| widget used to represent the 'thumb' of the scroll bar.
PushButton * | d_increase
| Widget used for the increase button of the scroll bar.
PushButton * | d_decrease
| Widget used for the decrease button of the scroll bar.

## Detailed Description

Base scroll bar class.

This base class for scroll bars does not have any idea of direction - a derived class would add whatever meaning is appropriate according to what that derived class represents to the user.

## Member Function Documentation

virtual PushButton* CEGUI::Scrollbar::createDecreaseButton | ( | const String & | name | ) | const`[protected, pure virtual]`

  | create a PushButton based widget to use as the decrease button for this scroll bar. Parameters:
  | name | String holding the name that must be passed when creating the component widget.

virtual PushButton* CEGUI::Scrollbar::createIncreaseButton | ( | const String & | name | ) | const`[protected, pure virtual]`

  | create a PushButton based widget to use as the increase button for this scroll bar. Parameters:
  | name | String holding the name that must be passed when creating the component widget.

virtual Thumb* CEGUI::Scrollbar::createThumb | ( | const String & | name | ) | const`[protected, pure virtual]`

  | create a Thumb based widget to use as the thumb for this scroll bar. Parameters:
  | name | String holding the name that must be passed when creating the component widget.

virtual float CEGUI::Scrollbar::getAdjustDirectionFromPoint | ( | const Point & | pt | ) | const`[protected, pure virtual]`

  | Given window location pt, return a value indicating what change should be made to the scroll bar. Parameters:
  | pt | Point object describing a pixel position in window space.
Returns: -1 to indicate scroll bar position should be moved to a lower value. 0 to indicate scroll bar position should not be changed. +1 to indicate scroll bar position should be moved to a higher value.

float CEGUI::Scrollbar::getDocumentSize | ( | void |  | ) | const`[inline]`

| Return the size of the document or data. The document size should be thought of as the total size of the data that is being scrolled through (the number of lines in a text file for example). Note: The returned value has no meaning within the Gui system, it is left up to the application to assign appropriate values for the application specific use of the scroll bar. Returns: float value specifying the currently set document size.

float CEGUI::Scrollbar::getOverlapSize | ( | void |  | ) | const`[inline]`

| Return the overlap size for this scroll bar. The overlap size is the amount of data from the end of a 'page' that will remain visible when the position is moved by a page. This is usually used so that the user keeps some context of where they were within the document's data when jumping a page at a time. Note: The returned value has no meaning within the Gui system, it is left up to the application to assign appropriate values for the application specific use of the scroll bar. Returns: float value specifying the currently set overlap size.

float CEGUI::Scrollbar::getPageSize | ( | void |  | ) | const`[inline]`

| Return the page size for this scroll bar. The page size is typically the amount of data that can be displayed at one time. This value is also used when calculating the amount the position will change when you click either side of the scroll bar thumb - the amount the position changes will is (pageSize - overlapSize). Note: The returned value has no meaning within the Gui system, it is left up to the application to assign appropriate values for the application specific use of the scroll bar. Returns: float value specifying the currently set page size.

float CEGUI::Scrollbar::getScrollPosition | ( | void |  | ) | const`[inline]`

| Return the current position of scroll bar within the document. The range of the scroll bar is from 0 to the size of the document minus the size of a page (0 <= position <= (documentSize - pageSize)). Note: The returned value has no meaning within the Gui system, it is left up to the application to assign appropriate values for the application specific use of the scroll bar. Returns: float value specifying the current position of the scroll bar within its document.

float CEGUI::Scrollbar::getStepSize | ( | void |  | ) | const`[inline]`

| Return the step size for this scroll bar. The step size is typically a single unit of data that can be displayed, this is the amount the position will change when you click either of the arrow buttons on the scroll bar. (this could be 1 for a single line of text, for example). Note: The returned value has no meaning within the Gui system, it is left up to the application to assign appropriate values for the application specific use of the scroll bar. Returns: float value specifying the currently set step size.

virtual float CEGUI::Scrollbar::getValueFromThumb | ( | void |  | ) | const`[protected, pure virtual]`

| return value that best represents current scroll bar position given the current location of the thumb. Returns: float value that, given the thumb widget position, best represents the current position for the scroll bar.

void CEGUI::Scrollbar::initialise | ( | void |  | ) | `[virtual]`

| Initialises the Scrollbar object ready for use. Note: This must be called for every window created. Normally this is handled automatically by the WindowFactory for each Window type. Returns: Nothing Reimplemented from CEGUI::Window.

void CEGUI::Scrollbar::onMouseButtonDown | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when a mouse button has been depressed within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented from CEGUI::Window.

void CEGUI::Scrollbar::onMouseWheel | ( | MouseEventArgs & | e | ) | `[protected, virtual]`

  | Handler called when the mouse wheel (z-axis) position changes within this window's area. Parameters:
  | e | MouseEventArgs object. All fields are valid.
Reimplemented from CEGUI::Window.

void CEGUI::Scrollbar::setDocumentSize | ( | float | document_size | ) |

  | Set the size of the document or data. The document size should be thought of as the total size of the data that is being scrolled through (the number of lines in a text file for example). Note: The value set has no meaning within the Gui system, it is left up to the application to assign appropriate values for the application specific use of the scroll bar. Parameters:
  | document_size | float value specifying the document size.
Returns: Nothing.

void CEGUI::Scrollbar::setOverlapSize | ( | float | overlap_size | ) |

  | Set the overlap size for this scroll bar. The overlap size is the amount of data from the end of a 'page' that will remain visible when the position is moved by a page. This is usually used so that the user keeps some context of where they were within the document's data when jumping a page at a time. Note: The value set has no meaning within the Gui system, it is left up to the application to assign appropriate values for the application specific use of the scroll bar. Parameters:
  | overlap_size | float value specifying the overlap size.
Returns: Nothing.

void CEGUI::Scrollbar::setPageSize | ( | float | page_size | ) |

  | Set the page size for this scroll bar. The page size is typically the amount of data that can be displayed at one time. This value is also used when calculating the amount the position will change when you click either side of the scroll bar thumb - the amount the position changes will is (pageSize - overlapSize). Note: The value set has no meaning within the Gui system, it is left up to the application to assign appropriate values for the application specific use of the scroll bar. Parameters:
  | page_size | float value specifying the page size.
Returns: Nothing.

void CEGUI::Scrollbar::setScrollPosition | ( | float | position | ) |

  | Set the current position of scroll bar within the document. The range of the scroll bar is from 0 to the size of the document minus the size of a page (0 <= position <= (documentSize - pageSize)), any attempt to set the position outside this range will be adjusted so that it falls within the legal range. Note: The returned value has no meaning within the Gui system, it is left up to the application to assign appropriate values for the application specific use of the scroll bar. Parameters:
  | position | float value specifying the position of the scroll bar within its document.
Returns: Nothing.

void CEGUI::Scrollbar::setStepSize | ( | float | step_size | ) |

  | Set the step size for this scroll bar. The step size is typically a single unit of data that can be displayed, this is the amount the position will change when you click either of the arrow buttons on the scroll bar. (this could be 1 for a single line of text, for example). Note: The value set has no meaning within the Gui system, it is left up to the application to assign appropriate values for the application specific use of the scroll bar. Parameters:
  | step_size | float value specifying the step size.
Returns: Nothing.

virtual bool CEGUI::Scrollbar::testClassName_impl | ( | const String & | class_name | ) | const`[inline, protected, virtual]`

  | Return whether this window was inherited from the given class name at some point in the inheritance heirarchy. Parameters:
  | class_name | The class name that is to be checked.
Returns: true if this window was inherited from class_name. false if not. Reimplemented from CEGUI::Window.